org.apache.solr.client.solrj.cloud.autoscaling

## Class FreeDiskVariable

- java.lang.Object
- - org.apache.solr.client.solrj.cloud.autoscaling.VariableBase
  - - org.apache.solr.client.solrj.cloud.autoscaling.FreeDiskVariable

All Implemented Interfaces:
  Variable

    public class FreeDiskVariable
    extends VariableBase

### Nested Class Summary

### Nested classes/interfaces inherited from class org.apache.solr.client.solrj.cloud.autoscaling.VariableBase

`VariableBase.CoreIndexSizeVariable, VariableBase.DiskTypeVariable, VariableBase.LazyVariable, VariableBase.TotalDiskVariable`

### Nested classes/interfaces inherited from interface org.apache.solr.client.solrj.cloud.autoscaling.Variable

`Variable.Meta, Variable.Type`

### Field Summary

### Fields inherited from interface org.apache.solr.client.solrj.cloud.autoscaling.Variable

`coreidxsize, NULL`

### Constructor Summary

Constructors
Constructor and Description
`FreeDiskVariable(Variable.Type type)`

### Method Summary

All Methods Instance Methods Concrete Methods
`int` `compareViolation(Violation v1, Violation v2)`
`void` `computeDeviation(Policy.Session session, double[] deviation, org.apache.solr.client.solrj.cloud.autoscaling.ReplicaCount replicaCount, SealedClause sealedClause)`
`Object` `computeValue(Policy.Session session, Condition condition, String collection, String shard, String node)` When a non constant value is used in a variable, the actual value needs to be computed at the runtime
`Object` `convertVal(Object val)`
`void` `getSuggestions(org.apache.solr.client.solrj.cloud.autoscaling.Suggestion.Ctx ctx)`
`void` `projectAddReplica(Cell cell, ReplicaInfo ri, Consumer<org.apache.solr.client.solrj.cloud.autoscaling.Row.OperationInfo> ops, boolean strictMode)`
`void` `projectRemoveReplica(Cell cell, ReplicaInfo ri, Consumer<org.apache.solr.client.solrj.cloud.autoscaling.Row.OperationInfo> opCollector)`

### Methods inherited from class org.apache.solr.client.solrj.cloud.autoscaling.VariableBase

`getTagType, postValidate, validate`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.apache.solr.client.solrj.cloud.autoscaling.Variable

`addViolatingReplicas, getOperand, match`

### Constructor Detail

#### FreeDiskVariable

    public FreeDiskVariable(Variable.Type type)

### Method Detail

#### convertVal

    public Object convertVal(Object val)

#### computeValue

    public Object computeValue(Policy.Session session,
                               Condition condition,
                               String collection,
                               String shard,
                               String node)

Description copied from interface: `Variable`
When a non constant value is used in a variable, the actual value needs to be computed at the runtime

#### compareViolation

    public int compareViolation(Violation v1,
                                Violation v2)

Specified by:
  `compareViolation` in interface `Variable`
Overrides:
  `compareViolation` in class `VariableBase`

#### computeDeviation

    public void computeDeviation(Policy.Session session,
                                 double[] deviation,
                                 org.apache.solr.client.solrj.cloud.autoscaling.ReplicaCount replicaCount,
                                 SealedClause sealedClause)

#### getSuggestions

    public void getSuggestions(org.apache.solr.client.solrj.cloud.autoscaling.Suggestion.Ctx ctx)

Specified by:
  `getSuggestions` in interface `Variable`
Overrides:
  `getSuggestions` in class `VariableBase`

#### projectAddReplica

    public void projectAddReplica(Cell cell,
                                  ReplicaInfo ri,
                                  Consumer<org.apache.solr.client.solrj.cloud.autoscaling.Row.OperationInfo> ops,
                                  boolean strictMode)

#### projectRemoveReplica

    public void projectRemoveReplica(Cell cell,
                                     ReplicaInfo ri,
                                     Consumer<org.apache.solr.client.solrj.cloud.autoscaling.Row.OperationInfo> opCollector)